import { ClassConstructor } from '../class-transformer';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from '../types';
export declare type ClassMapValueReturn<T> = (T[keyof T] | unknown | unknown[])[];
export declare class ClassTransformerForArray {
    static instance: ClassTransformerForArray;
    plainMapValue<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ArrayStorageOptions): Partial<T>;
    classMapValue<T>(classType: ClassConstructor<T>, object: Partial<T>, options?: ArrayStorageOptions): ClassMapValueReturn<Partial<T>>;
    plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ClassTransformForArrayOptions & {
        isArray?: false;
    }): T;
    plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[][], options?: ClassTransformForArrayOptions & {
        isArray: true;
    }): T[];
    classToPlainArray<T extends object>(object: Exclude<T, unknown[]>, options?: ClassToPlainArrayOptions): ClassMapValueReturn<T>;
    classToPlainArray<T extends object>(object: T[], options?: ClassToPlainArrayOptions): ClassMapValueReturn<T>[];
    arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
        isArray?: false;
    }): Promise<T>;
    arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
        isArray: true;
    }): Promise<T[]>;
    arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
        isArray?: false;
    }): T;
    arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
        isArray: true;
    }): T[];
}
//# sourceMappingURL=ClassTransformerForArray.d.ts.map