import { ClassConstructor } from './class-transformer';
import { ClassMapValueReturn } from './core';
import { ArrayStorageOptions, ClassToPlainArrayOptions, ClassTransformForArrayOptions, TransformValidationForArrayOptions } from './types';
export * from './decorators';
export * from './storages';
export * from './exceptions';
export * from './types';
export * from './core';
export declare function plainMapValue<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ArrayStorageOptions): Partial<T>;
export declare function classMapValue<T>(classType: ClassConstructor<T>, object: Partial<T>, options?: ArrayStorageOptions): ClassMapValueReturn<Partial<T>>;
export declare function plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[][], options?: ClassTransformForArrayOptions & {
    isArray: true;
}): T[];
export declare function plainArrayToClass<T, TData>(classType: ClassConstructor<T>, array: TData[], options?: ClassTransformForArrayOptions & {
    isArray?: false;
}): T;
export declare function classToPlainArray<T extends object>(object: Exclude<T, unknown[]>, options?: ClassToPlainArrayOptions): ClassMapValueReturn<T>;
export declare function classToPlainArray<T extends object>(object: T[], options?: ClassToPlainArrayOptions): ClassMapValueReturn<T>[];
export declare function arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): Promise<T>;
export declare function arrayTransformAndValidate<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): Promise<T[]>;
export declare function arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[], options?: TransformValidationForArrayOptions & {
    isArray?: false;
}): T;
export declare function arrayTransformAndValidateSync<T extends object, TData>(classType: ClassConstructor<T>, array: TData[][], options?: TransformValidationForArrayOptions & {
    isArray: true;
}): T[];
//# sourceMappingURL=index.d.ts.map