"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultArrayMemberStorage = exports.ArrayMemberStorage = void 0;
/* eslint-disable @typescript-eslint/ban-types */
const PropertyIndex_1 = require("./PropertyIndex");
class ArrayMemberStorage {
    constructor() {
        this.map = new Map();
        this.mapMoved = new Map();
    }
    add(constructor, index, info) {
        const propertyIndex = this.map.get(constructor);
        if (propertyIndex) {
            propertyIndex.add(index, info);
        }
        else {
            const newMap = new PropertyIndex_1.PropertyIndex();
            // inherit
            for (const iterator of [this.mapMoved.entries(), this.map.entries()]) {
                for (const [c, propertyIndex] of iterator) {
                    if (constructor.prototype instanceof c) {
                        for (const [i, p] of propertyIndex.entries()) {
                            newMap.set(i, p);
                        }
                    }
                }
            }
            this.map.set(constructor, newMap.add(index, info));
        }
        return this;
    }
    has(constructor) {
        return this.map.has(constructor);
    }
    getPropertyIndex(constructor) {
        return this.map.get(constructor);
    }
}
exports.ArrayMemberStorage = ArrayMemberStorage;
ArrayMemberStorage.defaultArrayMemberStorage = new ArrayMemberStorage();
exports.defaultArrayMemberStorage = ArrayMemberStorage.defaultArrayMemberStorage;
//# sourceMappingURL=ArrayMemberStorage.js.map